# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Confluent::Mgmt::V2020_03_01
  module Models
    #
    # Organization resource.
    #
    class OrganizationResource

      include MsRestAzure

      # @return [String] The ARM id of the resource.
      attr_accessor :id

      # @return [String] The name of the resource.
      attr_accessor :name

      # @return [String] The type of the resource.
      attr_accessor :type

      # @return [DateTime] The creation time of the resource.
      attr_accessor :created_time

      # @return [ProvisionState] Provision states for confluent RP. Possible
      # values include: 'Accepted', 'Creating', 'Updating', 'Deleting',
      # 'Succeeded', 'Failed', 'Canceled', 'Deleted', 'NotSpecified'
      attr_accessor :provisioning_state

      # @return [String] Id of the Confluent organization.
      attr_accessor :organization_id

      # @return [String] SSO url for the Confluent organization.
      attr_accessor :sso_url

      # @return [OrganizationResourcePropertiesOfferDetail] Confluent offer
      # detail
      attr_accessor :offer_detail

      # @return [OrganizationResourcePropertiesUserDetail] Subscriber detail
      attr_accessor :user_detail

      # @return [Hash{String => String}] Organization resource tags
      attr_accessor :tags

      # @return [String] Location of Organization resource
      attr_accessor :location


      #
      # Mapper for OrganizationResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OrganizationResource',
          type: {
            name: 'Composite',
            class_name: 'OrganizationResource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              created_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdTime',
                type: {
                  name: 'DateTime'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              organization_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.organizationId',
                type: {
                  name: 'String'
                }
              },
              sso_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.ssoUrl',
                type: {
                  name: 'String'
                }
              },
              offer_detail: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.offerDetail',
                type: {
                  name: 'Composite',
                  class_name: 'OrganizationResourcePropertiesOfferDetail'
                }
              },
              user_detail: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.userDetail',
                type: {
                  name: 'Composite',
                  class_name: 'OrganizationResourcePropertiesUserDetail'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
